/*******************************************************************************
Copyright © 2023 Sebastian Roith

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*******************************************************************************/

window.TASK = function(fktRandomInt) {
    function getUniqueValues(count, min, max) {
        const values = [];
        while (values.length < count) {
            const randomValue = fktRandomInt(min, max - values.length);
            values.push(values.slice().sort((a, b) => a - b).reduce((newValue, oldValue) => ((newValue >= oldValue) ? (newValue + 1) : newValue), randomValue));
        }
        return values;
    }

    const result = {
        task: 'Führe den Code aus, indem du immer die Auswirkungen der hervorgehobenen Zeile in der Speichertabelle einträgst und die nächste auszuführende Codezeile auswählst.',
        code: '',
        steps: []
    }

    const varType = 'int';
    const varNames = getUniqueValues(2, 'a'.charCodeAt(0), 'z'.charCodeAt(0)).map(code => String.fromCharCode(code));
    const varValues = getUniqueValues(2, 1, 5);
    const loopsVar = fktRandomInt(0, 1);
    const changeFirstIndex = fktRandomInt(0, 1);
    const monotonUps = [
        { random: [], code: (x, y) => (x + ' = ' + x + ' + ' + y), exec: (x, y) => (x + y) },
        { random: [], code: (x, y) => (x + ' = ' + y + ' + ' + x), exec: (x, y) => (x + y) },
        { random: [[1, 5]], code: (x, y, plus) => (x + ' = ' + x + ' + ' + plus), exec: (x, y, plus) => (x + plus) },
        { random: [[2, 4]], code: (x, y, mal) => (x + ' = ' + x + ' * ' + mal), exec: (x, y, mal) => (x * mal) },
        { random: [[1, 5]], code: (x, y, plus) => (x + ' = ' + plus + ' + ' + x), exec: (x, y, plus) => (x + plus) },
        { random: [[2, 4]], code: (x, y, mal) => (x + ' = ' + mal + ' * ' + x), exec: (x, y, mal) => (x * mal) }
        /*!*/
    ];
    let current = varValues.slice();
    const ups = varNames.map((varName, swap) => {
        const fktUp = monotonUps[fktRandomInt(0, monotonUps.length - 1)];
        const random = fktUp.random.map(([min, max]) => fktRandomInt(min, max));
        return {
            code() { return swap ? fktUp.code(varNames[1], varNames[0], ...random) : fktUp.code(...varNames, ...random); },
            exec() { current[swap ? 1 : 0] = swap ? fktUp.exec(current[1], current[0], ...random) : fktUp.exec(...current, ...random); }
        };
    });

    function genVars() {
        return [ { key: varNames[0], value: current[0], type: varType }, { key: varNames[1], value: current[1], type: varType } ];
    }

    result.steps.push({ line: 0, vars: [] });

    result.code = varType + ' ' + varNames[0] + ' = ' + varValues[0] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: [ { key: varNames[0], value: varValues[0], type: varType } ]
    });

    result.code += '\n' + varType + ' ' + varNames[1] + ' = ' + varValues[1] + ';';
    result.steps.push({
        line: (result.code.match(/\n/g) || []).length + 1,
        vars: genVars()
    });

    const lineLoopStart = (result.code.match(/\n/g) || []).length + 1;
    result.code += '\nwhile (BEDINGUNG) {';
    result.code += '\n    ' + ups[changeFirstIndex].code() + ';';
    result.code += '\n    ' + ups[1 - changeFirstIndex].code() + ';';
    result.code += '\n}';
    let lastLoopingValue = undefined;
    for (let n = fktRandomInt(2, 3); n > 0; --n) {
        lastLoopingValue = current[loopsVar];
        result.steps.push({ line: lineLoopStart + 1, vars: genVars() });
        ups[changeFirstIndex].exec();
        result.steps.push({ line: lineLoopStart + 2, vars: genVars() });
        ups[1 - changeFirstIndex].exec();
        result.steps.push({ line: lineLoopStart, altLines: [lineLoopStart + 3], vars: genVars() });
        if (current[loopsVar] > 99)
            break;
    }

    const breakValue = fktRandomInt(lastLoopingValue, current[loopsVar]);
    const useLowerOrEqual = (breakValue == lastLoopingValue) ? true : ((breakValue == current[loopsVar]) ? false : fktRandomInt(0, 1));
    const conditionCode = varNames[loopsVar] + (useLowerOrEqual ? ' <= ' : ' < ') + breakValue;
    result.code = result.code.replace('BEDINGUNG', conditionCode);

    result.steps.push({ line: Infinity, vars: genVars() });

console.log(result.steps);
    return result;
};
